> ## Documentation Index
> Fetch the complete documentation index at: https://docs.siftstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# CreateRule

> Creates a rule.



## OpenAPI

````yaml /openapi.json post /api/v1/rules
openapi: 3.0.0
info:
  title: Sift API
  version: '1.0'
servers:
  - url: https://api.siftstack.com
    description: Production
  - url: https://gov.api.siftstack.com
    description: Gov
security:
  - BearerAuth: []
tags:
  - name: TagService
    description: Service to programmatically interact with [tags](/glossary#tag).
  - name: ProtobufDescriptorService
    description: >-
      Service to programmatically interact with protobuf desciptors used for
      protobuf ingestion.
    externalDocs:
      description: Read more about what protobuf ingestion.
      url: /ingestion/protobuf_ingestion
  - name: ApiKeyService
  - name: UnitService
  - name: ChannelSchemaService
    description: Service to programmatically interact with channel schemas
  - name: PingService
  - name: SavedSearchService
  - name: IngestService
  - name: UserDefinedFunctionService
  - name: RoleService
  - name: DataImportService
  - name: AnnotationLogService
    description: >-
      Service to programmatically interact with [annotation
      logs](/glossary#annotation).
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: ExportService
  - name: AnnotationService
    description: Service to programmatically interact with annotations.
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: RuleEvaluationService
    description: Service to evaluate rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: CalculatedChannelsService
    description: Service to programmatically interact with calculated channels.
    externalDocs:
      description: Read more about calculated channels.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421153
  - name: CalculatedChannelService
  - name: MeService
  - name: UserService
    description: Service to programmatically interact with user objects.
  - name: RuleService
    description: Service to programmatically interact with rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: RemoteFileService
  - name: CampaignService
  - name: ReportTemplateService
  - name: JobService
  - name: DlqErrorsService
  - name: WebhookService
  - name: DataService
    description: Service to query data
  - name: ViewService
    description: Service to programmatically interact with views.
    externalDocs:
      description: Read more about what views are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/298188809
  - name: AssetService
    description: Service to programmatically interact with [assets](/glossary#asset).
    externalDocs:
      description: Read more about what assets are.
      url: /data-model
  - name: UserGroupService
  - name: RunService
    description: Service to programmatically interact with [runs](/glossary#run).
    externalDocs:
      description: Read more about what runs are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265454053
  - name: MetadataService
  - name: NotificationService
    description: Service to programmatically interact with in-app notifications.
  - name: PanelConfigurationService
    description: Service to programmatically interact with panel configurations.
  - name: IngestionConfigService
    description: >-
      Service to programmatically interact with [ingestion
      configs](/glossary#ingestion-config).
    externalDocs:
      description: Read more about what ingestion configs are.
      url: /ingestion/creating-amend-ingestion-config
  - name: ReportService
  - name: ExternalSyncService
  - name: ChannelService
    description: Service to programmatically interact with [channels](/glossary#channel).
    externalDocs:
      description: Read more about what channels are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265453943
paths:
  /api/v1/rules:
    post:
      tags:
        - RuleService
      summary: CreateRule
      description: Creates a rule.
      operationId: RuleService_CreateRule
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/v1CreateRuleRequest'
        required: true
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1CreateRuleResponse'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    v1CreateRuleRequest:
      type: object
      properties:
        update:
          $ref: '#/components/schemas/v1UpdateRuleRequest'
      required:
        - update
    v1CreateRuleResponse:
      type: object
      properties:
        ruleId:
          type: string
      required:
        - ruleId
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    v1UpdateRuleRequest:
      type: object
      properties:
        ruleId:
          type: string
        name:
          type: string
        description:
          type: string
        assetId:
          type: string
          description: Deprecated - use asset_configuration instead.
        isEnabled:
          type: boolean
          description: Deprecated - use DeleteRule instead.
        conditions:
          type: array
          items:
            $ref: '#/components/schemas/v1UpdateConditionRequest'
        organizationId:
          type: string
        versionNotes:
          type: string
        clientKey:
          type: string
          title: >-
            client_key is a client provided identifier for the rule. It is
            immutable after being set
        assetConfiguration:
          $ref: '#/components/schemas/v1RuleAssetConfiguration'
        contextualChannels:
          $ref: '#/components/schemas/v1ContextualChannels'
        isExternal:
          type: boolean
        metadata:
          type: array
          items:
            $ref: '#/components/schemas/v1MetadataValue'
      description: >-
        UpdateRuleRequest is used to create or update a rule. If the rule_id or
        client_key is provided, the rule will be updated. If not, a new rule
        will be created.
      required:
        - name
        - description
        - conditions
        - metadata
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    v1UpdateConditionRequest:
      type: object
      properties:
        ruleConditionId:
          type: string
        expression:
          $ref: '#/components/schemas/v1RuleConditionExpression'
        actions:
          type: array
          items:
            $ref: '#/components/schemas/v1UpdateActionRequest'
      required:
        - expression
        - actions
    v1RuleAssetConfiguration:
      type: object
      properties:
        assetIds:
          type: array
          items:
            type: string
        tagIds:
          type: array
          items:
            type: string
    v1ContextualChannels:
      type: object
      properties:
        channels:
          type: array
          items:
            $ref: '#/components/schemas/rulesv1ChannelReference'
      required:
        - channels
    v1MetadataValue:
      type: object
      properties:
        key:
          $ref: '#/components/schemas/v1MetadataKey'
        stringValue:
          type: string
        numberValue:
          type: number
          format: double
        booleanValue:
          type: boolean
        archivedDate:
          type: string
          format: date-time
      required:
        - key
    v1RuleConditionExpression:
      type: object
      properties:
        singleChannelComparison:
          $ref: '#/components/schemas/v1SingleChannelComparisonExpression'
        calculatedChannel:
          $ref: '#/components/schemas/siftrulesv1CalculatedChannelConfig'
    v1UpdateActionRequest:
      type: object
      properties:
        ruleActionId:
          type: string
        actionType:
          $ref: '#/components/schemas/v1ActionKind'
        configuration:
          $ref: '#/components/schemas/v1RuleActionConfiguration'
      required:
        - actionType
        - configuration
    rulesv1ChannelReference:
      type: object
      properties:
        name:
          type: string
        component:
          type: string
          title: >-
            Deprecated - use name instead. If provided, name will be joined with
            the component as `component.name`
      required:
        - name
        - component
    v1MetadataKey:
      type: object
      properties:
        name:
          type: string
        type:
          $ref: '#/components/schemas/v1MetadataKeyType'
        archivedDate:
          type: string
          format: date-time
      required:
        - name
        - type
    v1SingleChannelComparisonExpression:
      type: object
      properties:
        channelComponent:
          type: string
          title: >-
            Deprecated - use channel_name instead. If provided,
            channel_component will be joined with the name as
            `channel_component.channel_name`
        channelName:
          type: string
        comparator:
          $ref: '#/components/schemas/v1ConditionComparator'
        double:
          type: number
          format: double
        string:
          type: string
        lastValue:
          $ref: '#/components/schemas/v1LastValueThreshold'
      description: Deprecated - use CalculatedChannelConfig.
      required:
        - channelComponent
        - channelName
        - comparator
    siftrulesv1CalculatedChannelConfig:
      type: object
      properties:
        channelReferences:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/rulesv1ChannelReference'
        expression:
          type: string
        functionDependencies:
          type: array
          items:
            $ref: '#/components/schemas/v1FunctionDependency'
          description: >-
            This will be ignored in requests and will be generated
            automatically.
      required:
        - channelReferences
        - expression
    v1ActionKind:
      type: string
      enum:
        - ACTION_KIND_UNSPECIFIED
        - NOTIFICATION
        - ANNOTATION
        - WEBHOOK
      default: ACTION_KIND_UNSPECIFIED
    v1RuleActionConfiguration:
      type: object
      properties:
        notification:
          $ref: '#/components/schemas/v1NotificationActionConfiguration'
        annotation:
          $ref: '#/components/schemas/v1AnnotationActionConfiguration'
    v1MetadataKeyType:
      type: string
      enum:
        - METADATA_KEY_TYPE_UNSPECIFIED
        - METADATA_KEY_TYPE_STRING
        - METADATA_KEY_TYPE_NUMBER
        - METADATA_KEY_TYPE_BOOLEAN
      default: METADATA_KEY_TYPE_UNSPECIFIED
      description: |-
        Metadata key type.

         - METADATA_KEY_TYPE_STRING: string
         - METADATA_KEY_TYPE_NUMBER: number
         - METADATA_KEY_TYPE_BOOLEAN: boolean
    v1ConditionComparator:
      type: string
      enum:
        - CONDITION_COMPARATOR_UNSPECIFIED
        - LESS_THAN
        - LESS_THAN_OR_EQUAL
        - GREATER_THAN
        - GREATER_THAN_OR_EQUAL
        - EQUAL
        - NOT_EQUAL
      default: CONDITION_COMPARATOR_UNSPECIFIED
    v1LastValueThreshold:
      type: object
    v1FunctionDependency:
      type: object
      properties:
        userDefinedFunctionVersionId:
          type: string
      required:
        - userDefinedFunctionVersionId
    v1NotificationActionConfiguration:
      type: object
      properties:
        recipientUserIds:
          type: array
          items:
            type: string
      required:
        - recipientUserIds
    v1AnnotationActionConfiguration:
      type: object
      properties:
        tagIds:
          type: array
          items:
            type: string
        annotationType:
          $ref: '#/components/schemas/v1AnnotationType'
        assignedToUserId:
          type: string
        metadata:
          type: array
          items:
            $ref: '#/components/schemas/v1MetadataValue'
      required:
        - tagIds
    v1AnnotationType:
      type: string
      enum:
        - ANNOTATION_TYPE_UNSPECIFIED
        - ANNOTATION_TYPE_DATA_REVIEW
        - ANNOTATION_TYPE_PHASE
      default: ANNOTATION_TYPE_UNSPECIFIED
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````